#property copyright "Viatcheslav Suvorov"
#property show_inputs

extern datetime startdate=0;//    
extern datetime enddate=0;//    
extern bool ToLastData=true;//      
extern string instrument="EURUSD";// 
extern string genperiod="60";
extern int koefVola=8;

int start()
  {       if (ToLastData) enddate=iTime(instrument,StrToInteger(genperiod),0);
          if (startdate==0) {
            startdate=enddate-60*60*24*250;
            Print(TimeToStr(startdate)); 
          }  
          
          int ExtHandle=FileOpenHistory(instrument+genperiod+".hst", FILE_BIN|FILE_READ|FILE_WRITE);   
          if (ExtHandle>0) {          
               FileSeek(ExtHandle,148,SEEK_SET);           
               bool sign=true;
               MathSrand(TimeLocal());
               while (sign){

                 datetime t=FileReadInteger(ExtHandle,LONG_VALUE);
                 double o=FileReadDouble(ExtHandle,DOUBLE_VALUE);
                 double l=FileReadDouble(ExtHandle,DOUBLE_VALUE);
                 double h=FileReadDouble(ExtHandle,DOUBLE_VALUE);
                 double c=FileReadDouble(ExtHandle,DOUBLE_VALUE);
                 double v=FileReadDouble(ExtHandle,DOUBLE_VALUE);
                 double lastprice;
                 if ((t>=startdate) && (t<=enddate)) {
                   o=lastprice;
                   h=lastprice;
                   l=lastprice;
                   for (int i=0; i<v*koefVola;i++){
                     int rnd=MathRand();
                     int tick=0;
                     if (rnd<16384) tick=-1; else tick=+1;
                     lastprice=lastprice+tick*Point;
                     if (lastprice>h) h=lastprice;
                     if (lastprice<l) l=lastprice;
                   }//for
                   c=lastprice; 
                   FileSeek(ExtHandle,-44,SEEK_CUR); 
                   FileWriteInteger(ExtHandle, t, LONG_VALUE);
                   FileWriteDouble(ExtHandle, NormalizeDouble(o,Digits), DOUBLE_VALUE);
                   FileWriteDouble(ExtHandle, NormalizeDouble(l,Digits), DOUBLE_VALUE);
                   FileWriteDouble(ExtHandle, NormalizeDouble(h,Digits), DOUBLE_VALUE);
                   FileWriteDouble(ExtHandle, NormalizeDouble(c,Digits), DOUBLE_VALUE);
                   FileWriteDouble(ExtHandle, NormalizeDouble(v,0), DOUBLE_VALUE);        
                   FileFlush(ExtHandle);
                 } else lastprice=c;
                 
                 if (FileIsEnding(ExtHandle) || (t>=enddate)) sign=false;
               }//while
          }  else  return(0);         
   FileClose(ExtHandle);
   return(0);
  }//start

void deinit()
  { 
    
  }//deinit()

